
#include "hi_stdlib.h"
#include "lwip/sockets.h"
#include "lwip/netdb.h"
#include "mhttp.h"
#define HTTPC_DEMO_RECV_BUFSIZE 64
#define SOCK_TARGET_PORT  80

/*static const char *Request = "GET / HTTP/1.1\r\n\
Content-Type: application/x-www-form-urlencoded;charset=UTF-8\r\n\
Host: baidu.com\r\n\
Connection: close\r\n\
\r\n";*/

static const char *Request = "GET /rest/api3.do?api=mtop.common.getTimestamp HTTP/1.1\r\n\
Content-Type: application/json;charset=utf-8\r\n\
Host: api.m.taobao.com\r\n\
Connection: Keep Alive\r\n\
\r\n";

const char addr_ip[] = "140.205.162.6"; 
/*****************************************************************************
* Func description: demo for http get action
*****************************************************************************/
unsigned int http_clienti_get(void)
{
    struct sockaddr_in addr = {0};
    int s, r;
    char recv_buf[HTTPC_DEMO_RECV_BUFSIZE];
    addr.sin_family = AF_INET;
    addr.sin_port = PP_HTONS(SOCK_TARGET_PORT);
    addr.sin_addr.s_addr = inet_addr(addr_ip);
    s = socket(AF_INET, SOCK_STREAM, 0);
    if (s < 0) {
        return 1;
    }
    printf("... allocated socket");
    if (connect(s, (struct sockaddr*)&addr, sizeof(addr)) != 0) {
        printf("... socket connect failed errno=%d", errno);
        lwip_close(s);
        return 1;
    }
    printf("... connected");
    if (lwip_write(s, Request, strlen(Request)) < 0) {
        lwip_close(s);
        return 1;
    }
    printf("... socket send success");
    struct timeval receiving_timeout;
    /* 5S Timeout */
    receiving_timeout.tv_sec = 5;
    receiving_timeout.tv_usec = 0;
    if (setsockopt(s, SOL_SOCKET, SO_RCVTIMEO, &receiving_timeout, sizeof(receiving_timeout)) < 0) {
        printf("... failed to set socket receiving timeout");
        lwip_close(s);
        return 1;
    }
    printf("... set socket receiving timeout success");
    /* Read HTTP response */
    do {
        (void)memset_s(recv_buf, sizeof(recv_buf), 0, sizeof(recv_buf));
        r = lwip_read(s, recv_buf, sizeof(recv_buf) - 1);
        for (int i = 0; i < r; i++) {
            
            putchar(recv_buf[i]);
        }
    } while (r > 0);
    printf("... done reading from socket. Last read return=%d errno=%d\r\n", r, errno);
    lwip_close(s);
    return 0;
}
/*
[17:05:58.800]收←◆... allocated socket
[17:05:58.842]收←◆... connected... socket send success... set socket receiving timeout success
[17:05:58.953]收←◆HTTP/1.1 200 OK
Server: nginx
Date: Fri, 11 Aug 2023 09:05:59-------------
 GMT
Content-Type: application/json;charset=UTF-8
Connection:-------------
 keep-alive
Content-length: 109
x-paramkey: mtop.common.getTi-------------
mestamp
s-rt: 0

{"api":"mtop.common.getTimestamp","v":"*","-------------
ret":["SUCCESS::鎺ュ彛璋冪敤鎴愬姛"],"data":{"t":"1691744759363-------------
"}}-------------


*/
